/* COMPRAS E SUPRIMENTOS */

ALTER TABLE TRABNECECOMP ADD NRDIASEGPROD VARCHAR2(3) NULL
/

ALTER TABLE PRODFORNCOMP ADD VRARREDEMPE FLOAT NULL
/

CREATE TABLE PRODEMPE
(
    CDFILIAL         VARCHAR2(4)            NOT NULL,
    CDPRODUTO        VARCHAR2(10)           NOT NULL,
    CONSTRAINT PK_PRODEMPE PRIMARY KEY (CDFILIAL, CDPRODUTO)
)
/

CREATE INDEX CMP00296_FK ON PRODEMPE (CDFILIAL ASC)
/

CREATE INDEX CMP00297_FK ON PRODEMPE (CDPRODUTO ASC)
/

ALTER TABLE PRODEMPE
   ADD CONSTRAINT FKCMP00296FILIAL FOREIGN KEY (CDFILIAL)
      REFERENCES FILIAL (CDFILIAL)
/

ALTER TABLE PRODEMPE
   ADD CONSTRAINT FKCMP00297PRODUTO FOREIGN KEY (CDPRODUTO)
      REFERENCES PRODUTO (CDPRODUTO)
/

/* MANUFATURA */

ALTER TABLE PROGPRODU ADD DTENTPROD DATE
/

UPDATE PROGPRODU SET DTENTPROD = SYSDATE WHERE DTENTPROD IS NULL
/

ALTER TABLE PROGPRODU MODIFY DTENTPROD DATE  NOT NULL
/

ALTER TABLE PREMATPPROGP DROP CONSTRAINT PK_PREMATPPROGP
/

ALTER TABLE CALPROGPROD DROP CONSTRAINT PK_CALPROGPROD
/

ALTER TABLE PREMATPPROGP DROP CONSTRAINT FKMAN01179PROGPROD
/

ALTER TABLE CALPROGPROD DROP CONSTRAINT FKMAN01214PROGPROD
/

ALTER TABLE PROGPRODU DROP CONSTRAINT PK_PROGPRODU
/

ALTER TABLE PROGPRODU ADD CONSTRAINT PK_PROGPRODU PRIMARY KEY (CDFILIAL, DTPROGPRODU, IDPRODVENACA, CDPRODUTO, DTENTPROD)
/

ALTER TABLE ITEMRETIEST ADD IDREQUIPROD VARCHAR2(1) DEFAULT 'N' NULL
   CONSTRAINT CKC_49412354 CHECK (IDREQUIPROD IS NULL OR (IDREQUIPROD IN ('S','N')))
/

ALTER TABLE PREMATPPROGP ADD DTENTPROD DATE
/

UPDATE PREMATPPROGP SET DTENTPROD = SYSDATE WHERE DTENTPROD IS NULL
/

ALTER TABLE PROGPRODU ADD DTENTPROD DATE NOT NULL
/

ALTER TABLE PREMATPPROGP ADD CONSTRAINT PK_PREMATPPROGP PRIMARY KEY (CDFILIAL, DTPROGPRODU, IDPRODVENACA, CDPRODUTO, DTENTPROD, CDPRODPREVMP, QTPREVMATPRI)
/

DROP INDEX MAN01179_FK
/

CREATE INDEX MAN01179_FK ON PREMATPPROGP (CDPRODUTO ASC, CDFILIAL ASC, DTPROGPRODU ASC, IDPRODVENACA ASC, DTENTPROD ASC)
/

ALTER TABLE CALPROGPROD ADD DTENTPROD DATE
/

UPDATE CALPROGPROD SET DTENTPROD = SYSDATE WHERE DTENTPROD IS NULL
/

ALTER TABLE CALPROGPROD MODIFY DTENTPROD DATE NOT NULL
/

ALTER TABLE CALPROGPROD ADD CONSTRAINT PK_CALPROGPROD PRIMARY KEY (CDFILIAL, DTPROGPRODU, IDPRODVENACA, CDPRODUTO, DTENTPROD, NRCALPROGPRO)
/

DROP INDEX MAN01214_FK
/

CREATE INDEX MAN01214_FK ON CALPROGPROD (CDPRODUTO ASC, CDFILIAL ASC, DTPROGPRODU ASC, IDPRODVENACA ASC, DTENTPROD ASC)
/

CREATE TABLE TEMPOETAFABR
(
    CDPRODUTO        VARCHAR2(10)           NOT NULL,
    CDPROCFABRIC     VARCHAR2(10)           NOT NULL,
    CDETAPAPROD      VARCHAR2(10)           NOT NULL,
    NRSEQTEMPETA     VARCHAR2(3)            NOT NULL,
    VRINIQTFABPR     FLOAT                  NOT NULL,
    VRFINQTFABPR     FLOAT                  NOT NULL,
    QTHRETFABRPR     FLOAT                  NULL    ,
    CONSTRAINT PK_TEMPOETAFABR PRIMARY KEY (CDPRODUTO, CDPROCFABRIC, CDETAPAPROD, NRSEQTEMPETA)
)
/

CREATE INDEX MAN01256_FK ON TEMPOETAFABR (CDETAPAPROD ASC, CDPROCFABRIC ASC, CDPRODUTO ASC)
/

ALTER TABLE PREMATPPROGP
   ADD CONSTRAINT FKMAN01179PROGPROD FOREIGN KEY (CDPRODUTO, CDFILIAL, DTPROGPRODU, IDPRODVENACA, DTENTPROD)
      REFERENCES PROGPRODU (CDPRODUTO, CDFILIAL, DTPROGPRODU, IDPRODVENACA, DTENTPROD)
/

ALTER TABLE CALPROGPROD
   ADD CONSTRAINT FKMAN01214PROGPROD FOREIGN KEY (CDPRODUTO, CDFILIAL, DTPROGPRODU, IDPRODVENACA, DTENTPROD)
      REFERENCES PROGPRODU (CDPRODUTO, CDFILIAL, DTPROGPRODU, IDPRODVENACA, DTENTPROD) ON DELETE CASCADE
/

ALTER TABLE TEMPOETAFABR
   ADD CONSTRAINT FKMAN01256ETAFABRI FOREIGN KEY (CDETAPAPROD, CDPROCFABRIC, CDPRODUTO)
      REFERENCES ETAFABRIC (CDETAPAPROD, CDPROCFABRIC, CDPRODUTO)
/

/* RESTAURANTE */

ALTER TABLE VENDAREST DROP CONSTRAINT FKPDV00298CLIENTE
/

ALTER TABLE VENDAREST DROP CONSTRAINT FKPDV00299CONSUMID
/

ALTER TABLE VENDAREST DROP COLUMN CDCLIENTE
/

ALTER TABLE VENDAREST DROP COLUMN CDCONSUMIDOR
/

DROP INDEX PDV00298_FK
/

DROP INDEX PDV00299_FK
/

/* COMISSARIA */

ALTER TABLE COMPPROD ADD CDPRODUTOAUX VARCHAR2(10) NULL
/

DROP INDEX PCP00186_FK
/

CREATE INDEX PCP00186_FK ON COMPPROD (CDPRODUTOAUX ASC, CDESPPRODAUX ASC)
/

ALTER TABLE COMPPROD DROP CONSTRAINT FKPCP00169ESPEPROD
/

ALTER TABLE COMPPROD
   ADD CONSTRAINT FKPCP00186ESPEPROD FOREIGN KEY (CDPRODUTOAUX, CDESPPRODAUX)
      REFERENCES ESPEPROD (CDPRODUTO, CDESPEPROD)
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZACAO_ESTRUTURA_BD','4.05.041'); END;
/

