CREATE OR REPLACE PROCEDURE PREVISAO_SERVICO_COC(
P_NRPREVSVCOC IN FLOAT
)
AS
V_NRSUBGRUPO VARCHAR2(20);
V_NRPRODUTO VARCHAR2(20);
V_NRRECEITA VARCHAR2(20);

V_QTREND FLOAT;
BEGIN
   DELETE FROM PRODPREVSVCOC WHERE NRPREVSVCOC = P_NRPREVSVCOC;
   DELETE FROM RECPREVSVCOC WHERE NRPREVSVCOC = P_NRPREVSVCOC;
   DELETE FROM SUBGRUPREVSVCOC WHERE NRPREVSVCOC = P_NRPREVSVCOC;
   
   -- Pegar subgrupos de servios da previso que esto amarrados em manuais vigentes
   FOR C_SUBGRUPOS IN
   (
      SELECT S.CDSERVICO, M.CDMANCIA, 
             SG.CDPRODINSUMO AS CDSUBGRUPO, S.NRSERVPREVSVCOC,
             SM.CDESPEPROD,
             ROUND(S.QTSERVPREVSVCOC * NVL(SG.VRLOADCOMP, 0)/100, 3) AS QTSUBGRUPO, 
             SG.VRLOADCOMP AS VRPELOAD
        FROM SERVPREVSVCOC S
             INNER JOIN ESPEPROD SM ON SM.CDPRODUTO = S.CDSERVICO
             INNER JOIN MANUALCIA M ON M.CDFILIAL = SM.CDFILIAL AND
                                       M.CDCIA = SM.CDCIA AND
                                       M.CDMANCIA = SM.CDMANCIA
             INNER JOIN COMPPROD SG ON SG.CDPRODUTO = SM.CDPRODUTO AND
                                       SG.CDESPEPROD = SM.CDESPEPROD
             INNER JOIN PRODUTO PT ON PT.CDPRODUTO = SG.CDPRODINSUMO AND
                                      PT.IDPRODCOMISS = '2' --Subgrupo
       WHERE S.NRPREVSVCOC = P_NRPREVSVCOC
         AND TRUNC(SYSDATE) BETWEEN M.DTINIVGMA AND NVL(M.DTFIMVGMA, TRUNC(SYSDATE))
         AND M.IDTPMANUAL = 'M'
   ) LOOP
      NOVO_CODIGO_SC('SUBGRUPREVSVCOC',V_NRSUBGRUPO);
      
      -- Inserir subgrupo
      INSERT INTO SUBGRUPREVSVCOC
      (NRSUBGRUPREVSVCOC, NRPREVSVCOC, NRSERVPREVSVCOC, 
       CDSUBGRUPO, CDMANCIA, VRPELOAD)
      VALUES
      (TO_NUMBER(V_NRSUBGRUPO), P_NRPREVSVCOC, C_SUBGRUPOS.NRSERVPREVSVCOC, 
       C_SUBGRUPOS.CDSUBGRUPO, C_SUBGRUPOS.CDMANCIA, C_SUBGRUPOS.VRPELOAD);
       
      -- Inserir composio do subgrupo. Valor do produto calculado como quantidade * qtde. subgrupo * Yield
      FOR C_COMPOSICAO_SG IN
      (
         SELECT PT.CDPRODUTO, ROUND(QTINSUMO * C_SUBGRUPOS.QTSUBGRUPO, 3) AS QUANTIDADE, S.CDSETOR,
                CASE WHEN PT.IDPRODCOMISS IS NULL THEN 'P' ELSE 'R' END AS TIPO
           FROM COMPPROD C
                INNER JOIN PRODUTO PT ON PT.CDPRODUTO = C.CDPRODINSUMO
                LEFT JOIN SETOR S ON S.CDSETOR = PT.CDSETOR
          WHERE C.CDPRODUTO = C_SUBGRUPOS.CDSUBGRUPO
            AND C.CDPRODUTOAUX = C_SUBGRUPOS.CDSERVICO
            AND C.CDESPPRODAUX = C_SUBGRUPOS.CDESPEPROD
            AND (PT.IDPRODCOMISS IS NULL OR PT.IDPRODCOMISS = '3') --produtos ou receitas
      ) LOOP
         
         IF C_COMPOSICAO_SG.TIPO = 'P' THEN           
            IF C_COMPOSICAO_SG.QUANTIDADE > 0 THEN
               NOVO_CODIGO_SC('PRODPREVSVCOC',V_NRPRODUTO);
               
               INSERT INTO PRODPREVSVCOC
               (NRPRODPREVSVCOC , NRSUBGRUPREVSVCOC, NRPREVSVCOC,
                NRSERVPREVSVCOC, NRRECPREVSVCOC, CDRECEITA, CDPRODUTO,
                CDSETOR, QTPRODPREVSVCOC)
               VALUES
               (TO_NUMBER(V_NRPRODUTO), V_NRSUBGRUPO, P_NRPREVSVCOC,
                C_SUBGRUPOS.NRSERVPREVSVCOC, NULL, NULL, C_COMPOSICAO_SG.CDPRODUTO,
                NULL,C_COMPOSICAO_SG.QUANTIDADE);
            END IF;
         ELSE
            SELECT MAX(QTREND)
              INTO V_QTREND
              FROM
            (SELECT NVL(QTRENDRECLOC, 0) AS QTREND
               FROM RENDLOCAL
               WHERE CDRECEITA = C_COMPOSICAO_SG.CDPRODUTO
            UNION
            SELECT NVL(QTRENDRECPAD, 0) AS QTREND
              FROM RENDPADRAO
             WHERE CDRECEITA = C_COMPOSICAO_SG.CDPRODUTO);
            
            IF V_QTREND > 0 AND C_COMPOSICAO_SG.QUANTIDADE > 0 THEN
               NOVO_CODIGO_SC('RECPREVSVCOC',V_NRRECEITA);
               
               INSERT INTO RECPREVSVCOC
               (NRRECPREVSVCOC, NRSUBGRUPREVSVCOC, NRPREVSVCOC,
                NRSERVPREVSVCOC, NRRECPAI, CDRECEITA, CDRECEITAORI,
                CDRECEITAPAI,CDSETOR, QTRECPREVSVCOC,
                QTRENDRECPREVSVCOC)
               VALUES
               (TO_NUMBER(V_NRRECEITA), V_NRSUBGRUPO, P_NRPREVSVCOC,
                C_SUBGRUPOS.NRSERVPREVSVCOC, NULL, C_COMPOSICAO_SG.CDPRODUTO, NULL,
                NULL, C_COMPOSICAO_SG.CDSETOR, C_COMPOSICAO_SG.QUANTIDADE,
                V_QTREND);
               
               -- Insere composio da receita
               COMPOSICAO_RECEITA_PREVSVCOC(TO_NUMBER(V_NRRECEITA));
            END IF;
         END IF;
         
      END LOOP;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('PREVISAO_SERVICO_COC','5.85.xxx'); END;
/